-- | Infix operators for construction of paragraphs with readable code.
--
-- Example construction:
-- @en = (,) SpanOptions { spanLanguage = "en" }@
-- @ja = (,) SpanOptions { spanLanguage = "ja" }@
-- @"ignored prefix" |\< en "one two " \>|\< ja "三四" \>| "ignored suffix"@
--
-- Special syntax for paragraphs with no contents:
-- @"ignored prefix" |<>| "ignored suffix"@
module Data.Text.ParagraphLayout.ParagraphConstruction
    ((>|)
    ,(>|<)
    ,(|<)
    ,(|<>|)
    )
where

import Data.Text.ParagraphLayout.Internal.ParagraphConstruction
